{{{  comments
; This macro-package gives you the possibility to beautify texts.
; The text-paragraphs will be `filled'. All lines should have the same
; length.
; The filling can be done in three modes:
; * block   - all lines have exact the same length
; * ragged  - ``  '' replaced by `` ''
; * roff    - ``. '' replaced by ``.  '' (active after startup)
; a paragraph ends at a line beginning with ``.'' or if the
; indentation has changed.
;
; fill-paragraph does this filling
;
; inv-blank-handle skips between the fill-modes
;
; set-fill-column changes the width of a paragraph
;   width is given:
;      1: REPEAT-ARGUMENT
;   or 2: position of cursor
;   or 3: (if cursor is to near to the beginning of a line) by
;         keyboardinput
;
; previous-paragraph next-paragraph are macros skipping between
;   paragraphs (ROFF-syntax)
}}}
nodup
{{{  libs
{{{F error.fun
:::F error.fun
}}}
{{{F delspaces.fun
:::F delspaces.fun
}}}
}}}
{{{  used variables
; single-blank       ``. '' is not replaced with ``.  ''
;                    ``  '' are peplaced by `` ''
; fill-column        # chars in block
; fill-start         start of lines
; fill-begin         first char in block
; fill-end           last char in block
; fill-x
; fill-count
}}}
{{{  fill-paragraph
{{{  pre-handle-line
(deffun pre-handle-line (
  O_START_OF_LINE
  if counter-0 single-blank (
    {{{  expand ``. '' to ``.  ''
    while not(test-end-line) (
      {{{  maybe expand ``. ''
      if test-char ". (
        O_RIGHT
        if test-char "  (
          O_RIGHT
          if not(test-char " ) (" ) fi
        ) fi
      ) fi
      }}}
      O_RIGHT
    )
    }}}
  ) else (
    {{{  ``  ''->:`` ''
    while not(test-end-line) (
      if not(test-char " ) (
        O_RIGHT
      ) else (
        O_RIGHT
        delspaces
        O_RIGHT
      ) fi
    )
    }}}
  ) fi
))
}}}
{{{  post-last-handle
(defmac post-last-handle (
  if counter>0 single-blank ( pre-handle-line ) fi
))
}}}
{{{  post-handle-line
(deffun post-handle-line (
  if counter>0 single-blank (
    {{{  expand line exact to fill column
    {{{  fill-post-c = number of missing spaces
    goto-counter fill-end
    set-counter fill-post-c 0
    while and(not(test-begin-line),test-char " ) (
      add-counter fill-post-c 1
      O_LEFT
    )
    }}}
    do (
      {{{  one line pass, fill-post-x=0, if space found
      {{{  move cursor to correct position
      if counter-0 fill-para-space-po (
        set-counter fill-post-x 1
        O_END_OF_LINE
      ) else (
        set-counter fill-post-x 0
        goto-counter fill-para-space-po
        while test-end-line (O_LEFT)
        O_RIGHT
      ) fi
      }}}
      while and(counter>0 fill-post-c,not(test-begin-line)) (
        {{{  maybe insert space, go left
        O_LEFT
        if test-char " (
          "  ;
          O_LEFT
          O_LEFT
          set-counter fill-post-x 0
          add-counter fill-post-c -1
        ) fi
        }}}
      )
      if test-begin-line (set-counter fill-para-space-po 0) fi
      }}}
    ) while and(counter>0 fill-post-c,counter-0 fill-post-x)
    store-pos fill-para-space-po
    }}}
  ) fi
))
}}}
{{{  fill-line
(defmac fill-line
(
  {{{  how many chars needed, which position in next line
  O_END_OF_LINE
  store-pos fill-count
  O_LEFT
  if and(counter-0 single-blank,test-char ".) (add-counter fill-count 1) fi
  inv-counter fill-count
  sum-counter fill-count fill-end
  set-counter fill-x 0
  sum-counter fill-x fill-count
  sum-counter fill-x fill-begin
  }}}
  O_DOWN
  goto-counter fill-x
  if test-end-line (
    {{{  next line to short
    goto-counter fill-start
    delspaces
    O_DELETE
    "  ;
    O_LEFT
    O_LEFT
    if test-char ". (O_RIGHT " ) fi
    }}}
  ) else (
    {{{  line long enough
    {{{  search splitt positions
    while and(counter>0 fill-count,not(test-char " )) (
      O_LEFT
      add-counter fill-count -1
    )
    }}}
    if counter>0 fill-count (
      {{{  can splitt
      O_RETURN
      goto-counter fill-begin
      delspaces
      O_UP
      goto-counter fill-start
      delspaces
      O_DELETE
      "  ;
      O_LEFT
      O_LEFT
      if test-char ". (O_RIGHT " ) fi
      O_DOWN
      }}}
    ) fi
    O_UP
    post-handle-line
    O_DOWN
    }}}
  ) fi
))
}}}
{{{  splitt-line
(defmac splitt-line
(
  goto-counter fill-end
  O_RIGHT
  set-counter fill-count 0
  sum-counter fill-count fill-column
  {{{  look for a splitt-position
  while and(counter>0 fill-count,not(test-char " )) (
    O_LEFT
    add-counter fill-count -1
  )
  if counter-0 fill-count (oops) fi
  }}}
  O_RETURN
  goto-counter fill-begin
  delspaces
))
}}}
{{{  fill-block
(defmac fill-block (
  if not(test-text) (oops) fi
  if counter-0 fill-column  (set-counter fill-column 72) fi
  {{{  set start/begin/end/fillpo
  O_START_OF_LINE
  store-pos fill-begin
  O_RETURN
  O_UP
  O_START_OF_LINE
  store-pos fill-start
  O_DEL_LINE
  set-counter fill-end -1
  sum-counter fill-end fill-begin
  sum-counter fill-end fill-column
  set-counter fill-para-space-po 0
  }}}
  pre-handle-line
  while test-text (
    {{{  handle one line (current line is maybe to short, but prehandled)
    goto-counter fill-begin
    {{{  "." or " " at begin or not start-of-line => ready
    if or(or(test-char " ,test-char ".),not(test-begin-line)) (
      return-from-macro
    ) fi
    }}}
    goto-counter fill-end
    O_RIGHT
    if test-end-line (
      {{{  fill or leave
      O_LEFT
      if test-end-line (
        {{{  fill it
        O_DOWN
        goto-counter fill-begin
        {{{  "." or " " at begin or not start-of-line or no text => ready
        if or(or(test-char " ,test-char ".),
              or(not(test-text),not(test-begin-line)))
        (
          O_UP
          post-handle-line
          O_DOWN
          return-from-macro
        ) fi
        }}}
        pre-handle-line
        O_UP
        fill-line
        }}}
      ) else (
        {{{  line exact ok
        post-handle-line
        O_DOWN
        pre-handle-line
        }}}
      ) fi
      }}}
    ) else (
      {{{  splitting
      splitt-line
      O_UP
      post-handle-line
      O_DOWN
      }}}
    ) fi
    }}}
  )
))
}}}
(deffun fill-paragraph (
  fill-block
  O_UP
  post-last-handle
))
}}}
{{{  set-fill-column
(deffun set-fill-column
(
  {{{  initalize fil-column to 72 if never used before
  if counter-0 fill-column ( set-counter fill-column 72 ) fi
  }}}
  read-repeat fill-x
  {{{  use numeric argument if any
  if counter>0 fill-x (
    set-counter fill-column 1
    sum-counter fill-column fill-x
    return-from-macro
  ) fi
  }}}
  {{{  else: fill-end = cursor position
  store-pos fill-x
  set-counter fill-end 0
  sum-counter fill-end fill-x
  O_START_OF_LINE
  store-pos fill-start
  goto-counter fill-x
  inv-counter fill-start
  sum-counter fill-end fill-start
  add-counter fill-end 1
  }}}
  add-counter fill-end -20
  {{{  use distance between line-start and cursor-position, if greater than 20
  if counter>0 fill-end (
    set-counter fill-column 20
    sum-counter fill-column fill-end
    return-from-macro
  ) fi
  }}}
  {{{  else prompt for the correct value
  prompt-counter fill-end ( "set-fill-column: " )
  if not(counter>0 fill-end) ( oops ) fi
  set-counter fill-column 0
  sum-counter fill-column fill-end
  }}}
))
}}}
{{{  inv-blank-handle
(deffun inv-blank-handle (
  if counter-0 single-blank (
    set-counter single-blank 1
    message-exit "block
  ) fi
  if counter>0 single-blank (
    set-counter single-blank -1
    message-exit "ragged
  ) fi
  set-counter single-blank 0
  message-exit "roff
))
}}}
{{{  previous-paragraph
(deffun previous-paragraph (
  O_UP
  set-counter fill-x 0
  {{{  skip comments
  while counter-0 fill-x (
    while and(not(test-top),not(test-text)) (
      if test-fold-line (
        O_OPEN_FOLD
        while not(test-end-fold) (O_DOWN)
      ) fi
      O_UP
    )
    O_START_OF_LINE
    if not(test-char ".) (set-counter fill-x 1) else (O_UP) fi
  )
  }}}
  O_START_OF_LINE
  set-counter fill-x 0
  {{{  skip current paragraph
  while counter-0 fill-x (
    if or(or(test-char " ,test-char ".),not(test-begin-line)) (
      set-counter fill-x 1
      O_DOWN
    ) else (
      O_UP
      if test-top (oops) fi
    ) fi
  )
  }}}
))
}}}
{{{  next-paragraph
(deffun next-paragraph (
  O_START_OF_LINE
  {{{  skip current paragraph
  store-pos fill-begin
  if test-text (set-counter fill-x 1) else (set-counter fill-x 0) fi
  while counter>0 fill-x (
    goto-counter fill-begin
    if or(or(test-char " ,test-char ".),not(test-begin-line)) (
      set-counter fill-x 0
    ) else (
      O_DOWN
    ) fi
  )
  }}}
  {{{  skip 'comments'
  while counter-0 fill-x (
    while and(not(test-bottom),not(test-text)) (
      if test-fold-line ( O_OPEN_FOLD ) fi
      O_DOWN
    )
    O_START_OF_LINE
    if not(test-char ".) (set-counter fill-x 1) else (O_DOWN) fi
  )
  }}}
  if not(test-text) (oops) fi
))
}}}
