{{{  comments
; some macros doing different actions dependend on the currently set mode.
}}}
nodup
{{{  description
; mode-number mode-tag mode-name
;      0
;      2      c-mode   C-Mode
;      3      p-mode   PASCAL-M
;      4      r-mode   ROFF-M
;      5      t-mode   TEX-Mode
;      6      o-mode   OCCAM-M
;      7      m-mode   MIRA-M
}}}
{{{  standard-filter
(deffun standard-filter (
  case
    (counter>0 c-mode (filter-buffer "cb O_RETURN))
    (or(counter>0 p-mode,or(counter>0 o-mode,counter>0 m-mode)) (message-exit "no_filter_given))
  default
    ( fill-paragraph )
  esac
))
}}}
{{{  standard-up
{{{  occam-up
(defmac occam-up (
  O_START_OF_LINE
  O_LEFT
  store-pos start-up-x
  do (
    if test-begin-fold (O_CLOSE_FOLD) fi
    O_UP
    while test-fold-line (
      O_OPEN_FOLD
      mtool-bot
      O_UP
    )
    goto-counter start-up-x
  ) while and(not(test-top),or(test-char " ,not(test-text)))
))
}}}
(deffun standard-up (
  case
    (counter>0 c-mode (O_FIND_REVERSE "{ ))
    (counter>0 r-mode (previous-paragraph))
    (counter>0 t-mode (previous-paragraph))
    (counter>0 p-mode (O_FIND_REVERSE "begin))
    (counter>0 o-mode (occam-up))
  esac
))
}}}
{{{  standard-down
{{{  occam-down
(defmac occam-down (
  O_START_OF_LINE
  store-pos start-up-x
  do (
    if test-end-fold (O_CLOSE_FOLD) fi
    O_DOWN
    while test-fold-line (O_OPEN_FOLD O_DOWN)
    O_START_OF_LINE
    store-pos start-up-y
    inv-counter start-up-y
    sum-counter start-up-y start-up-x
  ) while and(not(test-bottom),or(not(counter>0 start-up-y),not(test-text)))
))
}}}
(deffun standard-down (
  case
    (counter>0 c-mode (O_RIGHT O_FIND "{ ))
    (counter>0 r-mode (next-paragraph))
    (counter>0 t-mode (next-paragraph))
    (counter>0 p-mode (O_RIGHT O_FIND "begin))
    (counter>0 o-mode (occam-down))
  esac
))
}}}
{{{  c-mode-stuff
{{{  parens
(deffun parens
(
  if or(counter>0 p-mode,counter>0 c-mode) (
    "( ")
    backward-character
  ) else (
    "(
  ) fi
))
}}}
{{{  brackets
(deffun brackets
(
  if or(counter>0 p-mode,counter>0 c-mode) (
    "[]
    backward-character
  ) else (
    "[
  ) fi
))
}}}
{{{  curly brackets
(deffun curly-brackets
(
  if or(counter>0 c-mode,counter>0 p-mode) (
    {{{  corrrect position?!
    store-pos x_pos_cb
    beginning-of-line
    if test-char "  (
      goto-counter x_pos_cb
    ) else (
      end-of-line
      "  ;
    ) fi
    }}}
    if counter>0 c-mode ("{ ) else ("begin ) fi
    newline-and-indent
    if counter>0 c-mode ("} ) else ("end ) fi
    previous-line
    end-of-line
    newline-and-indent
    forward-character forward-character
  ) else (
    "{
  ) fi
))
}}}
{{{  doublequotes
(deffun doublequotes
(
  if or(counter>0 p-mode,counter>0 c-mode) (
    "" ""
    backward-character
  ) else (
    ""
  ) fi
))
}}}
{{{  singlequotes
(deffun singlequotes
(
  if or(counter>0 p-mode,counter>0 c-mode) (
    "' "'
    backward-character
  ) else (
    "'
  ) fi
))
}}}
{{{  semicolon
(deffun semicolon (

  if or(counter>0 p-mode,counter>0 c-mode) (
    end-of-line
    O_LEFT
    if not(test-char ";) (
      if not(test-char " ) (O_RIGHT) fi
      ";
    ) fi
    beginning-of-line
    store-pos x_pos_sem
    O_DOWN
    beginning-of-line
    if test-char "  (
      O_UP beginning-of-line O_DOWN
    ) else (
      store-pos x2_pos_sem
      inv-counter x2_pos_sem
      sum-counter x_pos_sem x2_pos_sem
      if counter>0 x_pos_sem (O_UP end-of-line O_RETURN) fi
    ) fi
  ) else (
    ";
  ) fi
))
}}}
}}}
